![Pipeline status](https://gitlab.eclipse.org/eclipse/aidge/aidge_backend_cpu/badges/main/pipeline.svg?ignore_skipped=true) ![C++ coverage](https://gitlab.eclipse.org/eclipse/aidge/aidge_backend_cpu/badges/main/coverage.svg?job=coverage:ubuntu_cpp&key_text=C%2B%2B+coverage&key_width=90) ![Python coverage](https://gitlab.eclipse.org/eclipse/aidge/aidge_backend_cpu/badges/main/coverage.svg?job=coverage:ubuntu_python&key_text=Python+coverage&key_width=100)

# Aidge CPU library

You can find in this folder the library that implements the CPU operators. <br>
Those operators can be used on any machine with an Linux OS.

[TOC]

## Installation

### Dependencies
- `GCC`
- `Make`/`Ninja`
- `CMake`
- `Python` (optional, if you have no intend to use this library in python with pybind)

#### Aidge dependencies
 - `aidge_core`

### Pip installation
``` bash
pip install . -v
```
> **TIPS :** Use environment variables to change compilation options :
> - `AIDGE_INSTALL` : to set the installation folder. Defaults to /usr/local/lib. :warning: This path must be identical to aidge_core install path.
> - `AIDGE_PYTHON_BUILD_TYPE` : to set the compilation mode to **Debug** or **Release** 
> - `AIDGE_BUILD_GEN` : to set the build backend with 

### Standard C++ Compilation

You will need to compile first the Core library before compiling the CPU one.
The makefile is designed to do it for you.

To only compile the CPU library, run
```
make cpu_only
```

To compile the CPU library + the associated unitary tests, run
```
make cpu_tests
```

To compile the CPU library with the python binding, run
```
make cpu_with_pybind
```
Important: this command can also be run with `make`.


To compile the CPU library with the python binding + the associated unitary tests, run
```
make cpu_with_pybind_tests
```
